## ros-melodic-ariles-ros 1.3.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(ariles_ros VERSION 1.3.2)


option(ARILES_ROS_ENABLE_TESTS "Enable tests." OFF)

set(ARILES_DIR             "${CMAKE_CURRENT_SOURCE_DIR}/ariles")

set(CMAKE_VERBOSE_MAKEFILE ON)
#-----
# ARILES
set(ARILES_CPP_STANDARD         "c++11" CACHE STRING "")

set(ARILES_DEFAULT_CONFIGURABLE_FLAGS "ariles::ConfigurableFlags::SLOPPY_MAPS_IF_SUPPORTED | ariles::ConfigurableFlags::SLOPPY_PAIRS_IF_SUPPORTED" CACHE STRING "")
set(ARILES_BRIDGES_DEFAULT_MODE "OFF"   CACHE STRING "")
set(ARILES_BRIDGE_yaml_cpp      "ON"    CACHE STRING "")
set(ARILES_BRIDGE_ros           "ON"    CACHE STRING "")
set(ARILES_BRIDGE_octave        "ON"    CACHE STRING "")
set(ARILES_BRIDGE_array         "ON"    CACHE STRING "")

set(ARILES_ADAPTER_EIGEN            "ON"    CACHE STRING "")
set(ARILES_ADAPTER_BOOST_POINTER    "ON"    CACHE STRING "")
set(ARILES_ADAPTER_BOOST_OPTIONAL   "ON"    CACHE STRING "")

set(ARILES_BUILD_REGRESSION_TESTS   "${ARILES_ROS_ENABLE_TESTS}"   CACHE STRING "")
#-----

if(ARILES_ROS_ENABLE_TESTS)
    enable_testing()
endif()

add_subdirectory("${ARILES_DIR}" "./ariles")


set(ARILES_ROS_CONFIG_INSTALL_DESTINATION "${CMAKE_INSTALL_PREFIX}/share/${CMAKE_PROJECT_NAME}/cmake/")

include(CMakePackageConfigHelpers)
configure_package_config_file(  "cmake/${CMAKE_PROJECT_NAME}Config.cmake.in"
                                "${PROJECT_BINARY_DIR}/${CMAKE_PROJECT_NAME}Config.cmake"
                                INSTALL_DESTINATION "${ARILES_ROS_CONFIG_INSTALL_DESTINATION}"
                                NO_SET_AND_CHECK_MACRO
                                NO_CHECK_REQUIRED_COMPONENTS_MACRO)

write_basic_package_version_file(
    ${PROJECT_BINARY_DIR}/${CMAKE_PROJECT_NAME}ConfigVersion.cmake
    VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}
    COMPATIBILITY SameMajorVersion)

install(FILES package.xml DESTINATION share/${CMAKE_PROJECT_NAME}) # ?
install(FILES   "${PROJECT_BINARY_DIR}/${CMAKE_PROJECT_NAME}Config.cmake"
                DESTINATION ${ARILES_ROS_CONFIG_INSTALL_DESTINATION})
install(FILES   "${PROJECT_BINARY_DIR}/${CMAKE_PROJECT_NAME}ConfigVersion.cmake"
                DESTINATION ${ARILES_ROS_CONFIG_INSTALL_DESTINATION})

=== Makefile ===
VERSION?="XXX__version_not_set__XXX"

help:
	cat Makefile

update:
	git fetch --all
	git rm --ignore-unmatch -rf ariles
	git read-tree --prefix=ariles -u ${VERSION}
	${MAKE} cleanup

update_head:
	${MAKE} update VERSION="origin/master"

update_version: update
	sed -i -e "s=<version>[0-9]*\.[0-9]*\.[0-9]*</version>=<version>${VERSION}</version>=" package.xml
	sed -i -e "s=\(project([a-zA-Z0-9_-]* VERSION\) [0-9]*\.[0-9]*\.[0-9]*)=\1 ${VERSION})=" CMakeLists.txt


cleanup:
	git rm -rf --ignore-unmatch ariles/bridges/jsonnet/jsonnet
	git rm -rf --ignore-unmatch ariles/bridges/msgpack/msgpack-c
	git rm -rf --ignore-unmatch ariles/bridges/pugixml/pugixml
	git rm -rf --ignore-unmatch ariles/bridges/rapidjson/rapidjson
	git rm -rf --ignore-unmatch ariles/bridges/yaml_cpp/yaml-cpp
	git rm -rf --ignore-unmatch ariles/bridges/yaml_cpp03/yaml-cpp
	git rm -rf --ignore-unmatch ariles/.gitmodules
	git rm -rf --ignore-unmatch ariles/tests/catkin_package/
	git rm -rf --ignore-unmatch ariles/doc/dox

clean:
	rm -Rf build
	rm -Rf debian
	rm -Rf obj*

release:
	# 0. update_version
	# 1. Add Forthcoming section to the changelog
	# 2. Commit changelog
	catkin_prepare_release -t 'ros-' --version "${VERSION}" -y
	# 4. bloom-release --rosdistro melodic --track melodic ariles_ros


#==============================================
# CI
#==============================================

# ROS
#----------------------------------------------

add-ros-repos:
	sh -c "echo \"deb http://packages.ros.org/ros/ubuntu ${UBUNTU_DISTRO} main\" > /etc/apt/sources.list.d/ros-latest.list"
	sh -c "apt-key adv --keyserver hkp://ha.pool.sks-keyservers.net:80 --recv-key 421C365BD9FF1F717815A3895523BAEEB01FA116 \
		|| apt-key adv --keyserver hkp://ha.pool.sks-keyservers.net:80 --recv-key 421C365BD9FF1F717815A3895523BAEEB01FA116 \
		|| apt-key adv --keyserver hkp://ha.pool.sks-keyservers.net:80 --recv-key 421C365BD9FF1F717815A3895523BAEEB01FA116"
	apt-get update -qq
	apt-get install dpkg

install-ros:
	apt-get install -y ros-${ROS_DISTRO}-ros-base
	bash -c 'source /opt/ros/${ROS_DISTRO}/setup.bash; rosdep init'

# Dependencies
install-deps:
	apt update
#	apt upgrade -y
	apt install -y \
        libeigen3-dev \
        octave \
        libyaml-cpp-dev
	apt install -y \
		python-bloom \
		devscripts \
		debhelper
	apt install -y python-catkin-tools


ros-prerelease:
	sudo ${MAKE} add-ros-repos UBUNTU_DISTRO=${TRAVIS_UBUNTU_DISTRO}
	sudo apt update -y
	sudo apt install -y python3-ros-buildfarm
	mkdir -p /tmp/prerelease_job
	cd /tmp/prerelease_job && generate_prerelease_script.py \
		https://raw.githubusercontent.com/ros-infrastructure/ros_buildfarm_config/production/index.yaml \
		${ROS_DISTRO} default ubuntu ${UBUNTU_DISTRO} amd64 \
		ariles_ros \
		--custom-branch ariles_ros:${BRANCH} \
		--level 0 \
		--output-dir ./
	cd /tmp/prerelease_job && ./prerelease.sh


# catkin
#----------------------------------------------

CATKIN_WORKING_DIR?=./build/catkin_workspace
PKG_PATH?=${CATKIN_WORKING_DIR}/src/catkin_ariles
DEPENDENT_PKG_PATH?=${CATKIN_WORKING_DIR}/src/ariles_catkin_dependency_test


catkin-build-deb: clean
	cd ${PKG_PATH}; bloom-generate rosdebian --os-name ubuntu --ros-distro ${ROS_DISTRO} ./
	# disable installation of catkin stuff: setup scripts, etc.
	#cd ${PKG_PATH}; sed "s/dh_auto_configure --/dh_auto_configure -- -DCATKIN_BUILD_BINARY_PACKAGE=ON/" -i debian/rules
	cd ${PKG_PATH}; fakeroot debian/rules binary


catkin-test-deb: catkin-build-deb
	dpkg -i ../ros*ariles*.deb
	mkdir -p build/cmake_dependency_test
	bash -c 'source /opt/ros/${ROS_DISTRO}/setup.bash; \
             cd build/cmake_dependency_test; \
             cmake ../../tests/dependency/; \
             ${MAKE} ${MAKE_FLAGS}'


catkin-prepare-workspace: clean
	mkdir -p ${PKG_PATH}
	mkdir -p ${DEPENDENT_PKG_PATH}
	ls -1 | grep -v build | xargs cp -R -t ${PKG_PATH}
	cp -R tests/dependency/* ${DEPENDENT_PKG_PATH}/


catkin-old-build: catkin-prepare-workspace
	cd ${CATKIN_WORKING_DIR}/src; catkin_init_workspace
	cd ${CATKIN_WORKING_DIR}; catkin_make_isolated --pkg ariles_ros --cmake-args -DARILES_ROS_ENABLE_TESTS=ON --make-args all test # old

catkin-old-build-with-dependent: catkin-prepare-workspace
	cd ${CATKIN_WORKING_DIR}/src; catkin_init_workspace
	cd ${CATKIN_WORKING_DIR}; catkin_make_isolated

catkin-old-deb: catkin-prepare-workspace
	${MAKE} catkin-test-deb
	${MAKE} catkin-prepare-workspace
	rm -Rf ${PKG_PATH}
	cd ${CATKIN_WORKING_DIR}/src; catkin_init_workspace
	cd ${CATKIN_WORKING_DIR}; catkin_make_isolated --pkg ariles_catkin_dependency_test


catkin-new-build: catkin-prepare-workspace
	cd ${CATKIN_WORKING_DIR}; catkin init
	cd ${CATKIN_WORKING_DIR}; catkin build -i --verbose --summary ariles_ros --make-args all test --cmake-args -DARILES_ROS_ENABLE_TESTS=ON

catkin-new-build-with-dependent: catkin-prepare-workspace
	cd ${CATKIN_WORKING_DIR}; catkin init
	cd ${CATKIN_WORKING_DIR}; catkin build -i --verbose --summary ariles_catkin_dependency_test

catkin-new-deb:
	${MAKE} catkin-test-deb
	${MAKE} catkin-prepare-workspace
	rm -Rf ${PKG_PATH}
	cd ${CATKIN_WORKING_DIR}; catkin init
	cd ${CATKIN_WORKING_DIR}; catkin build -i --verbose --summary ariles_catkin_dependency_test


catkin-test-old: install-deps
	${MAKE} catkin-old-build
	${MAKE} catkin-old-build-with-dependent
	${MAKE} catkin-old-deb

catkin-test-new: install-deps
	${MAKE} catkin-new-build
	${MAKE} catkin-new-build-with-dependent
	${MAKE} catkin-new-deb



# docker
#----------------------------------------------
make-docker:
	docker pull ros:${ROS_DISTRO}-ros-base-${UBUNTU_DISTRO}
	docker run -ti ros:${ROS_DISTRO}-ros-base-${UBUNTU_DISTRO} \
		/bin/bash -c "source /opt/ros/${ROS_DISTRO}/setup.bash \
		&& git clone -b ${BRANCH} https://github.com/asherikov/ariles.git \
		&& cd ariles \
		&& make ${TARGET} ROS_DISTRO=${ROS_DISTRO} UBUNTU_DISTRO=${UBUNTU_DISTRO}"

=== ariles/CMakeLists.txt ===
# General parameters
cmake_minimum_required (VERSION 2.8.12)
project (ariles CXX)
set(ARILES_HOMEPAGE http://asherikov.github.com/ariles/)
set(PROJECT_VERSION_MAJOR 1)
set(PROJECT_VERSION_MINOR 3)
set(PROJECT_VERSION_PATCH 2)


include(FindPkgConfig)
include(ExternalProject)
include(CMakeParseArguments)
include(CPackComponent)
include(CMakePackageConfigHelpers)


set (CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/")

include(cmakeut_copy_dir_if_exists)
include(cmakeut_copy_file_if_exists)
include(cmakeut_add_external_git_project)
include(cmakeut_list_filenames)
include(cmakeut_dump_variables)
include(cmakeut_compiler_flags)

include (cmakeut_detect_func_macro)
cmakeut_detect_func_macro()



#####################################
## Options (definitions & defaults)
#####################################

option (ARILES_ENABLE_CORE              "Install core (if disable only selected bridges are installed)." ON)
option (ARILES_ENABLE_CORE_ALL_HEADER   "Generate ariles_all.h header (not suitable for packages)" ON)

# bridges
set    (ARILES_BRIDGES_DEFAULT_MODE     "BUILD" CACHE STRING "ON = enable, OFF = disable, BUILD = build from sources")
option (ARILES_INSTALL_BRIDGES          "Install bridges on the system (when mode = BUILD)." OFF)

# extra adapters & options
set (ARILES_DEFAULT_CONFIGURABLE_FLAGS  "" CACHE STRING "Override default flags")
set (ARILES_DEFAULT_FLOAT_VALUE         "std::numeric_limits<float>::signaling_NaN()" CACHE STRING "Default value for floats")
set (ARILES_DEFAULT_DOUBLE_VALUE        "std::numeric_limits<double>::signaling_NaN()" CACHE STRING "Default value for doubles")

option (ARILES_ADAPTER_EIGEN            "Enable eigen support." ON)
option (ARILES_ADAPTER_BOOST_POINTER    "Enable boost pointer support." ON)
option (ARILES_ADAPTER_BOOST_OPTIONAL   "Enable boost optional support." ON)
option (ARILES_ADAPTER_BETTER_ENUMS     "Enable support for beter enums." ON)

# build parameters
set    (ARILES_CPP_STANDARD             "c++98" CACHE STRING "C++ standard version")
option (ARILES_VERBOSE                  "Verbose build"                     ON)
option (ARILES_BUILD_REGRESSION_TESTS   "Build regression tests."           ON)
set    (ARILES_DEB_TARGETS              "" CACHE STRING "Enable debian package generation.")

# install parameters
set    (ARILES_PKGCONFIG_INSTALL_PATH   "" CACHE STRING "pkg-config pc-file install path, not installed if empty")



#####################################
## CPack configuration
#####################################

# CPACK_PACKAGE_NAME    If not specified, defaults to the project name.

set(CPACK_PACKAGE_VERSION_MAJOR ${PROJECT_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${PROJECT_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${PROJECT_VERSION_PATCH})

set(CPACK_PACKAGE_CONTACT "Alexander Sherikov <asherikov@yandex.com>")
set(CPACK_PACKAGE_VENDOR "https://github.com/asherikov/ariles")

#set(CPACK_PACKAGE_DESCRIPTION_FILE "${PROJECT_SOURCE_DIR}/README.md")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "C++ serialization library")

set(CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/LICENSE")

set(CPACK_MONOLITHIC_INSTALL OFF)
set(CPACK_DEB_COMPONENT_INSTALL ON)
set(CPACK_COMPONENTS_GROUPING ONE_PER_GROUP)


set(CPACK_GENERATOR "DEB")


set(CPACK_DEBIAN_PACKAGE_HOMEPAGE   "https://asherikov.github.io/ariles/")
set(CPACK_DEBIAN_PACKAGE_PRIORITY   "optional")
set(CPACK_DEBIAN_PACKAGE_SECTION    "devel")


#####################################

if (NOT ${ARILES_ENABLE_CORE})
    # tests cannot be built if the core is not installed
    set(ARILES_BUILD_REGRESSION_TESTS   OFF)

    # adapters are installed only with core
    set(ARILES_ADAPTER_EIGEN            OFF)
    set(ARILES_ADAPTER_BOOST_POINTER    OFF)
    set(ARILES_ADAPTER_BOOST_OPTIONAL   OFF)
    set(ARILES_ADAPTER_BETTER_ENUMS     OFF)
endif()



# Gather all cached options controlling compilation of the modules to unset
# those that are not valid anymore.
get_cmake_property(CACHED_VARIABLES CACHE_VARIABLES)
set(ARILES_CACHED_BRIDGES "")
foreach (CACHED_VARIABLE ${CACHED_VARIABLES})
    if (CACHED_VARIABLE MATCHES "ARILES_BRIDGE_.*")
        list(APPEND ARILES_CACHED_BRIDGES ${CACHED_VARIABLE})
    endif()
endforeach(CACHED_VARIABLE)


set(ARILES_BRIDGES_DIRS "${PROJECT_SOURCE_DIR}/bridges/")
set(ARILES_BRIDGES "")
set(ARILES_ENABLED_BRIDGES "")
foreach (ARILES_BRIDGES_DIR ${ARILES_BRIDGES_DIRS})
    cmakeut_list_filenames("${ARILES_BRIDGES_DIR}"  "ARILES_BRIDGES_TMP" DIRS_WITH_CMAKELISTS)
    list(APPEND ARILES_BRIDGES ${ARILES_BRIDGES_TMP})

    foreach(ARILES_BRIDGE ${ARILES_BRIDGES_TMP})
        set(ARILES_BRIDGE_${ARILES_BRIDGE}_DIR  "${ARILES_BRIDGES_DIR}/${ARILES_BRIDGE}")

        list(REMOVE_ITEM ARILES_CACHED_BRIDGES "ARILES_BRIDGE_${ARILES_BRIDGE}")
        if (DEFINED ARILES_BRIDGE_${ARILES_BRIDGE})
            set    ("ARILES_BRIDGE_${ARILES_BRIDGE}" "${ARILES_BRIDGE_${ARILES_BRIDGE}}"
                    CACHE STRING "Bridge '${ARILES_BRIDGE} (ON / OFF / BUILD)")

            if (NOT ${ARILES_BRIDGE_${ARILES_BRIDGE}} STREQUAL "OFF")
                list(APPEND ARILES_ENABLED_BRIDGES "${ARILES_BRIDGE}")
            endif()
        else()
            set    ("ARILES_BRIDGE_${ARILES_BRIDGE}" "${ARILES_BRIDGES_DEFAULT_MODE}"
                    CACHE STRING "Bridge '${ARILES_BRIDGE} (ON / OFF / BUILD)")

            if (NOT ${ARILES_BRIDGES_DEFAULT_MODE} STREQUAL "OFF")
                list(APPEND ARILES_ENABLED_BRIDGES "${ARILES_BRIDGE}")
            endif()
        endif()


        if (ARILES_VERBOSE)
            message("----------------------BRIDGE----------------------")
            message("Name: ${ARILES_BRIDGE}")
            message("Path: ${ARILES_BRIDGE_${ARILES_BRIDGE}_DIR}")
            message("Enabled: ${ARILES_BRIDGE_${ARILES_BRIDGE}}")
            message("Enable/disable option name: ARILES_BRIDGE_${ARILES_BRIDGE}")
            message("--------------------------------------------------")
        endif(ARILES_VERBOSE)
    endforeach(ARILES_BRIDGE)
endforeach(ARILES_BRIDGES_DIR)


set(ARILES_EXTRA_ADAPTERS "")
if (ARILES_ADAPTER_EIGEN)
    list(APPEND ARILES_EXTRA_ADAPTERS "eigen")
endif(ARILES_ADAPTER_EIGEN)
if (ARILES_ADAPTER_BOOST_POINTER)
    list(APPEND ARILES_EXTRA_ADAPTERS "boost_pointer")
endif(ARILES_ADAPTER_BOOST_POINTER)
if (ARILES_ADAPTER_BOOST_OPTIONAL)
    list(APPEND ARILES_EXTRA_ADAPTERS "boost_optional")
endif(ARILES_ADAPTER_BOOST_OPTIONAL)
if (ARILES_ADAPTER_BETTER_ENUMS)
    list(APPEND ARILES_EXTRA_ADAPTERS "better_enums")
endif(ARILES_ADAPTER_BETTER_ENUMS)


#####################################
## Settings
#####################################

add_custom_target( "${CMAKE_PROJECT_NAME}" )

##
## default options
##
if (ARILES_VERBOSE)
    set (CMAKE_VERBOSE_MAKEFILE     ON)
endif(ARILES_VERBOSE)
set (CMAKE_RULE_MESSAGES        OFF CACHE BOOL "")


##
## paths
##
set (ARILES_INCLUDE_DIR "${PROJECT_BINARY_DIR}/include/")


##
## compilation flags
##

# Set the build type.  Options are:
#  Coverage       : w/ debug symbols, w/o optimization, w/ code-coverage
#  Debug          : w/ debug symbols, w/o optimization
#  Release        : w/o debug symbols, w/ optimization
#  RelWithDebInfo : w/ debug symbols, w/ optimization
#  MinSizeRel     : w/o debug symbols, w/ optimization, stripped binaries
if(NOT CMAKE_BUILD_TYPE)
    set (CMAKE_BUILD_TYPE Debug)
endif (NOT CMAKE_BUILD_TYPE)


set (RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/bin")
set (LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/lib")
set (ARCHIVE_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/lib")

# AS. 'CMAKE_' prefix makes it default for all targets.
set (CMAKE_RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/bin")
set (CMAKE_LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/lib")
set (CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/lib")

# This will go to the configuration file for projects, which use ariles.
set (ARILES_CORE_INCLUDES "${CMAKE_INSTALL_PREFIX}/include")

set(DEB_ARCHIVE_FILES
    "./AUTHORS.md"
    "./CMakeLists.txt"
    "./LICENSE"
    "./Makefile"
    "./README.md"
    "./cmake"
    "./cpput")


#####################################
## Ariles headers
#####################################


# --------------
# cpput
# --------------
option(CPPUT_EMBEDDED "" ON)
set(CPPUT_EMBEDDED_ID "ARILES"  CACHE STRING "")
set(CPPUT_EMBEDDED_COPY_TO_DIR "${PROJECT_SOURCE_DIR}/include/ariles/internal/"  CACHE STRING "")
set(CPPUT_SELECT_HEADERS "config.h;better_enum.h;exception.h;floating_point_utils.h;visibility.h;misc.h;flags.h"  CACHE STRING "")
add_subdirectory(cpput)
# --------------


add_custom_target( TGT_ariles_copy_headers ALL )

# core & adapters headers are installed only in MIX or CORE mode.
if (${ARILES_ENABLE_CORE})
    cmakeut_copy_dir_if_exists(TGT_ariles_copy_headers          "ariles"
                              "${PROJECT_SOURCE_DIR}/include"  "${ARILES_INCLUDE_DIR}/core/")

    foreach(ARILES_EXTRA_ADAPTER ${ARILES_EXTRA_ADAPTERS})
        cmakeut_copy_dir_if_exists(
            TGT_ariles_copy_headers                                         "adapter_${ARILES_EXTRA_ADAPTER}"
            "${PROJECT_SOURCE_DIR}/extra_adapters/${ARILES_EXTRA_ADAPTER}"  "${ARILES_INCLUDE_DIR}/core/ariles/adapters/")
    endforeach()

    include_directories("${ARILES_INCLUDE_DIR}/core/")
    list(APPEND DEB_ARCHIVE_FILES "./include" "./extra_adapters")
endif()



#####################################
## Dependencies
#####################################

add_custom_target( TGT_fetch_bridges )
set(ARILES_TARGET_FETCH_BRIDGES    TGT_fetch_bridges CACHE INTERNAL "")

# Boost
find_package(Boost REQUIRED)
include_directories(SYSTEM ${Boost_INCLUDE_DIRS})
list(APPEND ARILES_CORE_DEPENDENCY_INCLUDES "${Boost_INCLUDE_DIRS}")


##
## Optional dependencies
##

set(BRIDGE_TARGET_PREFIX TGT_bridge)

if (ARILES_ADAPTER_EIGEN)
    find_package(Eigen3 REQUIRED)
    list(APPEND ARILES_CORE_DEPENDENCY_INCLUDES "${EIGEN3_INCLUDE_DIR}")
endif(ARILES_ADAPTER_EIGEN)

if (ARILES_ADAPTER_BOOST_POINTER)
    # BOOST is a mandatory dependency
endif(ARILES_ADAPTER_BOOST_POINTER)
if (ARILES_ADAPTER_BOOST_OPTIONAL)
    # BOOST is a mandatory dependency
endif(ARILES_ADAPTER_BOOST_OPTIONAL)


set (ARILES_BRIDGES_BINARY_DIR "${PROJECT_BINARY_DIR}/bridges/")
if (ARILES_INSTALL_BRIDGES)
    set(ARILES_BRIDGES_INSTALL_PREFIX   "${CMAKE_INSTALL_PREFIX}")
else()
    set(ARILES_BRIDGES_INSTALL_PREFIX   "${PROJECT_BINARY_DIR}/bridges_install/")
endif (ARILES_INSTALL_BRIDGES)


# TODO We use this to set CMAKE_INSTALL_LIBDIR in order to prevent creation of
# separate directories for different architectures. This is potentially unsafe
# if ARILES_INSTALL_BRIDGES = ON.
#
# It seems that the only robust solution is to work with ariles as an external
# project, where we would be able to use find_library().
set(ARILES_BRIDGES_LIBDIR       "${ARILES_BRIDGES_INSTALL_PREFIX}/lib")

set(ARILES_BRIDGES_INCLUDE_DIR      "${ARILES_BRIDGES_INSTALL_PREFIX}/include")
include_directories (BEFORE SYSTEM  "${ARILES_BRIDGES_INCLUDE_DIR}")


set(BRIDGES_ARGS
    --no-warn-unused-cli
    -DCMAKE_INSTALL_PREFIX=${ARILES_BRIDGES_INSTALL_PREFIX}
    -DCMAKE_INSTALL_LIBDIR=${ARILES_BRIDGES_LIBDIR}
    -DCMAKE_VERBOSE_MAKEFILE=${CMAKE_VERBOSE_MAKEFILE}
    -DCMAKE_BUILD_TYPE=Release)


if(CMAKE_TOOLCHAIN_FILE)
    if(NOT IS_ABSOLUTE ${CMAKE_TOOLCHAIN_FILE})
        set(CMAKE_TOOLCHAIN_FILE "${PROJECT_SOURCE_DIR}/${CMAKE_TOOLCHAIN_FILE}")
    endif()

    set(BRIDGES_ARGS
        ${BRIDGES_ARGS}
        "-DCMAKE_TOOLCHAIN_FILE=${CMAKE_TOOLCHAIN_FILE}")
endif(CMAKE_TOOLCHAIN_FILE)


# bridges
foreach(ARILES_BRIDGES_DIR ${ARILES_BRIDGES_DIRS})
    cmakeut_list_filenames("${ARILES_BRIDGES_DIR}"   "ARILES_BRIDGES_TMP" DIRS_WITH_CMAKELISTS)

    foreach(ARILES_BRIDGE ${ARILES_BRIDGES_TMP})
        if (NOT ${ARILES_BRIDGE_${ARILES_BRIDGE}} STREQUAL "OFF")
            set (${ARILES_BRIDGE}_INTERFACE_DIR  "${ARILES_BRIDGE_${ARILES_BRIDGE}_DIR}/interface")

=== ariles/Makefile ===
MAKE_FLAGS?=-j7


CMAKE_DIR=./cmake/
BUILD_DIR=./build/
ROOT_DIR=../../


# Toolchains
TC?=generic

OPTIONS?=default

# Build type as in CMAKE_BUILD_TYPE
TYPE?=Debug

TARGETS?=all

ARGS?=

DEB_TARGET?=xenial


#----------------------------------------------
# Cleaning
#----------------------------------------------

clean:
	rm -Rf build;
	rm -Rf include/ariles/internal/cpput_*.h
	git submodule update --init doc/dox/; cd doc/dox/; git clean -f; git reset --hard


#----------------------------------------------
# Generic targets
#----------------------------------------------

BUILD_SUBDIR=${BUILD_DIR}/${TC}-${TYPE}-OPTIONS_${OPTIONS}

build:
	mkdir -p ${BUILD_SUBDIR};
	cd ${BUILD_SUBDIR}; cmake 	-C ${ROOT_DIR}/tests/cmake_configs/options_${OPTIONS}.cmake\
								-DCMAKE_BUILD_TYPE=${TYPE} \
								-DCMAKE_TOOLCHAIN_FILE=${CMAKE_DIR}/toolchain_${TC}.cmake\
								${EXTRA_CMAKE_PARAM} \
								${ROOT_DIR};
	cd ${BUILD_SUBDIR}; ${MAKE} ${MAKE_FLAGS} ${TARGETS}

build-tests: build
	cd ${BUILD_SUBDIR}; ctest ${ARGS}
#	cd ${BUILD_SUBDIR}; ${MAKE} ${MAKE_FLAGS} test ${ARGS}

# -------

FETCH_DIR=${BUILD_DIR}/fetch

fetch:
	mkdir -p ${FETCH_DIR};
	cd ${FETCH_DIR}; cmake ${ROOT_DIR};
	cd ${FETCH_DIR}; ${MAKE} fetch-bridges;


#----------------------------------------------
# debug mode (all)
# Build & test
#----------------------------------------------

debug-all:
	${MAKE} build TC=${TC} TYPE=Debug TARGETS="${TARGETS}"

debug-all-tests:
	${MAKE} build-tests TC=${TC} TYPE=Debug TARGETS="${TARGETS}"

all: debug-all

debug: debug-all


#----------------------------------------------
# release mode
# Build & test
#----------------------------------------------

release-all:
	${MAKE} build TC=${TC} TYPE=Release TARGETS="${TARGETS}"

release-all-tests: release-all
	${MAKE} build-tests TC=${TC} TYPE=Release TARGETS="${TARGETS}"

release: release-all


#----------------------------------------------
# Debian packages
#----------------------------------------------

deb: clean
	${MAKE} build TC=${TC} TYPE=Release OPTIONS=deb_packages_${DEB_TARGET} TARGETS="pkg_deb" \
		EXTRA_CMAKE_PARAM="${EXTRA_CMAKE_PARAM} -DDEB_BUILDPACKAGE_FLAGS='-d'"

deb-build: clean
	${MAKE} build TC=${TC} TYPE=Release OPTIONS=deb_packages_${DEB_TARGET} TARGETS="pkg_deb" \
		EXTRA_CMAKE_PARAM="${EXTRA_CMAKE_PARAM} -DDEB_BUILDPACKAGE_FLAGS='-us;-uc'"
	cd build/generic-Release-OPTIONS_deb_packages_${DEB_TARGET}/Debian/${DEB_TARGET}/ariles-*-source; \
		dpkg-buildpackage -us -uc -F

deb-install:
	sudo dpkg -i build/generic-Release-OPTIONS_deb_packages_${DEB_TARGET}/Debian/${DEB_TARGET}/ariles-*.deb

deb-uninstall:
	dpkg --get-selections ariles* | awk '{print $1}' | xargs sudo dpkg -P

cmake_dependency: clean
	mkdir -p build/cmake_dependency_test
	cd build/cmake_dependency_test; cmake ../../tests/cmake_dependency/ -DARILES_COMPONENTS="core;ros;yaml-cpp"
	cd build/cmake_dependency_test; ${MAKE} ${MAKE_FLAGS}

ppa-upload:
	cd build/generic-Release-OPTIONS_deb_packages_trusty/Debian/trusty/; \
		ftp -au ppa.launchpad.net:~asherikov/ubuntu/ppa/ \
			ariles_*~${DEB_TARGET}.dsc \
			ariles_*~${DEB_TARGET}.tar.xz \
			ariles_*~${DEB_TARGET}_source.buildinfo \
			ariles_*~${DEB_TARGET}_source.changes


#----------------------------------------------
# checks
#----------------------------------------------


test-ros: clean
	${MAKE} build-tests TC=${TC} TYPE=Debug OPTIONS=default TARGETS="${TARGETS}" EXTRA_CMAKE_PARAM="${EXTRA_CMAKE_PARAM}"
	${MAKE} build-tests TC=${TC} TYPE=Debug OPTIONS=ros TARGETS="${TARGETS}" EXTRA_CMAKE_PARAM="${EXTRA_CMAKE_PARAM}"


test-noros: clean
	${MAKE} build TC=${TC} TYPE=Debug OPTIONS=no_core TARGETS="${TARGETS}" EXTRA_CMAKE_PARAM="${EXTRA_CMAKE_PARAM}"
	${MAKE} build-tests TC=${TC} TYPE=Debug OPTIONS=cpp11_on_noros TARGETS="${TARGETS}" EXTRA_CMAKE_PARAM="${EXTRA_CMAKE_PARAM}"
	${MAKE} build-tests TC=${TC} TYPE=Debug OPTIONS=cpp11_on_noros_sloppy TARGETS="${TARGETS}" EXTRA_CMAKE_PARAM="${EXTRA_CMAKE_PARAM}"
	${MAKE} build-tests TC=${TC} TYPE=Debug OPTIONS=cpp03_on_noros TARGETS="${TARGETS}" EXTRA_CMAKE_PARAM="${EXTRA_CMAKE_PARAM}"
	${MAKE} build-tests TC=${TC} TYPE=Debug OPTIONS=cpp11_build_noros TARGETS="${TARGETS}" EXTRA_CMAKE_PARAM="${EXTRA_CMAKE_PARAM}"
	${MAKE} build-tests TC=${TC} TYPE=Debug OPTIONS=cpp03_build_noros TARGETS="${TARGETS}" EXTRA_CMAKE_PARAM="${EXTRA_CMAKE_PARAM}"

test-cmake:
	${MAKE} build-tests TC=${TC} TYPE=Debug OPTIONS=conflict TARGETS="${TARGETS}" EXTRA_CMAKE_PARAM="${EXTRA_CMAKE_PARAM}"

#----------------------------------------------
# other
#----------------------------------------------

addutils:
	git remote add cmakeut https://github.com/asherikov/cmakeut
	git remote add cpput https://github.com/asherikov/cpput

updateutils:
	git fetch --all
	git show remotes/cmakeut/master:cmake/FindEigen3.cmake > cmake/FindEigen3.cmake
	git show remotes/cmakeut/master:cmake/cmakeut_add_external_git_project.cmake    > cmake/cmakeut_add_external_git_project.cmake
	git show remotes/cmakeut/master:cmake/cmakeut_compiler_flags.cmake              > cmake/cmakeut_compiler_flags.cmake
	git show remotes/cmakeut/master:cmake/cmakeut_copy_dir_if_exists.cmake          > cmake/cmakeut_copy_dir_if_exists.cmake
	git show remotes/cmakeut/master:cmake/cmakeut_copy_file_if_exists.cmake         > cmake/cmakeut_copy_file_if_exists.cmake
	git show remotes/cmakeut/master:cmake/cmakeut_detect_func_macro.cmake           > cmake/cmakeut_detect_func_macro.cmake
	git show remotes/cmakeut/master:cmake/cmakeut_dump_variables.cmake              > cmake/cmakeut_dump_variables.cmake
	git show remotes/cmakeut/master:cmake/cmakeut_list_filenames.cmake              > cmake/cmakeut_list_filenames.cmake
	git rm --ignore-unmatch -rf cpput
	git read-tree --prefix=cpput -u cpput/master


update:
	git submodule update

dox:
	cd doc; doxygen

install-ros:
	sh -c "echo \"deb http://packages.ros.org/ros/ubuntu ${UBUNTU_DISTRO} main\" > /etc/apt/sources.list.d/ros-latest.list"
	sh -c "apt-key adv --keyserver 'hkp://keyserver.ubuntu.com:80' --recv-key C1CF6E31E6BADE8868B172B4F42ED6FBAB17C654 \
	    || apt-key adv --keyserver 'hkp://keyserver.ubuntu.com:80' --recv-key C1CF6E31E6BADE8868B172B4F42ED6FBAB17C654 \
	    || apt-key adv --keyserver 'hkp://keyserver.ubuntu.com:80' --recv-key C1CF6E31E6BADE8868B172B4F42ED6FBAB17C654"
	sh -c "apt-key adv --keyserver 'hkp://keyserver.ubuntu.com:80' --recv-key 6B05F25D762E3157 \
	    || apt-key adv --keyserver 'hkp://keyserver.ubuntu.com:80' --recv-key 6B05F25D762E3157 \
	    || apt-key adv --keyserver 'hkp://keyserver.ubuntu.com:80' --recv-key 6B05F25D762E3157"
	apt-get update -qq
	apt-get install dpkg
	apt-get install -y ros-${ROS_DISTRO}-ros-base
	bash -c 'source /opt/ros/${ROS_DISTRO}/setup.bash; rosdep init'

.PHONY: clean cmake build

=== ariles/cpput/Makefile ===
BUILD_DIR?=build
MAKE_FLAGS?=-j1

INCLUDE_DIR=include/cpput/

default:
	@grep -v "^	" Makefile | grep -v "^$$"

clean:
	rm -Rf ${BUILD_DIR}
	ls ${INCLUDE_DIR}/*.in | sed 's/\.in$$//g' | xargs rm -f
	ls ${INCLUDE_DIR}/*.in | sed 's/\.in$$//g' | sed 's=${INCLUDE_DIR}/=${INCLUDE_DIR}/cpput_=' | xargs rm -f

build:
	mkdir -p ${BUILD_DIR}
	cd ${BUILD_DIR}; cmake ..
	cd ${BUILD_DIR}; make ${MAKE_FLAGS}

test: build
	cd build; ${MAKE} ${MAKE_FLAGS} test


addutils:
	git remote add cmakeut https://github.com/asherikov/cmakeut
	git remote add better_enums https://github.com/aantron/better-enums
	git remote add popl https://github.com/badaix/popl
	git remote add safe_int https://github.com/dcleblanc/SafeInt

3rdparty:
	git fetch --all
	git show remotes/cmakeut/master:cmake/cmakeut_add_cpp_test.cmake        > cmake/cmakeut_add_cpp_test.cmake
	git show remotes/cmakeut/master:cmake/cmakeut_compiler_flags.cmake      > cmake/cmakeut_compiler_flags.cmake
	git show remotes/cmakeut/master:cmake/cmakeut_detect_func_macro.cmake   > cmake/cmakeut_detect_func_macro.cmake
	git show remotes/cmakeut/master:cmake/cmakeut_list_filenames.cmake      > cmake/cmakeut_list_filenames.cmake
	git show remotes/better_enums/master:enum.h    > ${INCLUDE_DIR}/better_enum.h
	git show remotes/popl/master:include/popl.hpp  > ${INCLUDE_DIR}/popl.h
	git show remotes/safe_int/master:SafeInt.hpp   > ${INCLUDE_DIR}/safe_int.h
	${MAKE} allheader

allheader:
	echo "#ifndef H_CPPUT_ALL" > ${INCLUDE_DIR}/all.h
	echo "#define H_CPPUT_ALL" >> ${INCLUDE_DIR}/all.h
	cd ${INCLUDE_DIR}; ls *.h | grep -v "all.h" | sed 's/^\(.*\)/#include "\1"/' >> all.h
	cd ${INCLUDE_DIR}; ls *.h.in | grep -v "all.h" | sed 's/\.in$$//g' | sed 's/^\(.*\)/#include "\1"/' >> all.h
	echo "#endif" >> ${INCLUDE_DIR}/all.h
	cat ${INCLUDE_DIR}/all.h

gitignore:
	echo "build" > .gitignore
	ls ${INCLUDE_DIR}*.in | sed 's/\.in$$//g' >> .gitignore
	ls ${INCLUDE_DIR}*.in | sed 's/\.in$$//g' | sed 's=${INCLUDE_DIR}=${INCLUDE_DIR}cpput_=' >> .gitignore

.PHONY: build test 3rdparty

=== ariles/tests/CMakeLists.txt ===
if (ARILES_ADAPTER_EIGEN)
    find_package(Eigen3 REQUIRED)
    include_directories(SYSTEM ${EIGEN3_INCLUDE_DIR})
endif()
if (ARILES_ADAPTER_BOOST_POINTER)
endif(ARILES_ADAPTER_BOOST_POINTER)


find_package(Boost REQUIRED unit_test_framework timer random system)
include_directories(SYSTEM ${Boost_INCLUDE_DIRS})

# basic test for missing inlines
add_library(testlib SHARED testlib1.cpp testlib2.cpp)

list(APPEND ARILES_TESTING_LIBRARIES  "${Boost_LIBRARIES};testlib")

include(ariles_copy_extra_test_files)
include(ariles_define_regression_test)
include(ariles_define_test)
include(ariles_parse_test_dependencies)


set (CMAKE_RUNTIME_OUTPUT_DIRECTORY     "${PROJECT_BINARY_DIR}/tests_bin/")


# tests
set(ARILES_TEST_FILE_BRIDGES "yaml_cpp03;yaml_cpp;msgpack;rapidjson;jsonnet;pugixml")
set(ARILES_TEST_ALL_BRIDGES "${ARILES_TEST_FILE_BRIDGES};ros")
ariles_define_regression_test(${CMAKE_PROJECT_NAME} "000" "" "${ARILES_TEST_ALL_BRIDGES}")  # features
ariles_define_regression_test(${CMAKE_PROJECT_NAME} "001" "" "${ARILES_TEST_ALL_BRIDGES}")  # complex
ariles_define_regression_test(${CMAKE_PROJECT_NAME} "002" "" "${ARILES_TEST_ALL_BRIDGES}")  # inheritance, strictness
ariles_define_regression_test(${CMAKE_PROJECT_NAME} "003" "" "${ARILES_TEST_ALL_BRIDGES}")  # finalize
ariles_define_regression_test(${CMAKE_PROJECT_NAME} "004" "" "${ARILES_TEST_ALL_BRIDGES}")  # no adapters_all.h
ariles_define_regression_test(${CMAKE_PROJECT_NAME} "005" "" "${ARILES_TEST_ALL_BRIDGES}")  # disabled ariles
ariles_define_regression_test(${CMAKE_PROJECT_NAME} "009" "" "${ARILES_TEST_ALL_BRIDGES}")  # pointers (scalar)
ariles_define_regression_test(${CMAKE_PROJECT_NAME} "010" "rapidjson;jsonnet" "")           # jsonnet
ariles_define_regression_test(${CMAKE_PROJECT_NAME} "011" "rapidjson;yaml_cpp" "")          # bridge inclusion order
ariles_define_regression_test(${CMAKE_PROJECT_NAME} "012" "octave" "")                      # octave
ariles_define_regression_test(${CMAKE_PROJECT_NAME} "013" "" "${ARILES_TEST_ALL_BRIDGES}")  # special floats
ariles_define_regression_test(${CMAKE_PROJECT_NAME} "014" "" "${ARILES_TEST_FILE_BRIDGES}") # filenames
ariles_define_regression_test(${CMAKE_PROJECT_NAME} "015" "pugixml" "")                     # XML childs vs attributes
ariles_define_regression_test(${CMAKE_PROJECT_NAME} "016" "" "")                            # inclusion
ariles_define_regression_test(${CMAKE_PROJECT_NAME} "017" "" "${ARILES_TEST_ALL_BRIDGES}")  # any
ariles_define_regression_test(${CMAKE_PROJECT_NAME} "018" "" "${ARILES_TEST_ALL_BRIDGES}")  # pointers (configurable)
ariles_define_regression_test(${CMAKE_PROJECT_NAME} "019" "" "")                            # comparison (complex)
ariles_define_regression_test(${CMAKE_PROJECT_NAME} "020" "" "")                            # comparison (inheritance)
ariles_define_regression_test(${CMAKE_PROJECT_NAME} "021" "array" "")                       # array


ariles_define_test(${CMAKE_PROJECT_NAME} "demo" "yaml_cpp;ros;octave" "")

=== tests/dependency/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

set(CMAKE_VERBOSE_MAKEFILE ON)


if (DEFINED CATKIN_DEVEL_PREFIX)
    project(ariles_catkin_dependency_test)

    find_package(catkin REQUIRED ariles_ros)

    catkin_package(DEPENDS ariles_ros)

    include_directories(
        include
        SYSTEM ${catkin_INCLUDE_DIRS}
    )

    add_executable(demo demo.cpp)

    target_link_libraries(demo ${catkin_LIBRARIES})

    install(TARGETS demo
        ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
        LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
        RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
    )
else()
    project(ariles_cmake_dependency_test)

    find_package(ariles_ros REQUIRED)

    include_directories(${ariles_ros_INCLUDE_DIRS})

    add_executable(demo demo.cpp)
    target_link_libraries(demo ${ariles_ros_LIBRARIES})
endif()

=== ariles/bridges/array/CMakeLists.txt ===
cmakeut_copy_file_if_exists( TGT_ariles_copy_headers                         "bridge_array_h"
                            "${${ARILES_BRIDGE}_INTERFACE_DIR}/array.h"    "${ARILES_BRIDGE_INCLUDE_DIR}/")
cmakeut_copy_dir_if_exists(  TGT_ariles_copy_headers                         "bridge_array_dir"
                            "${${ARILES_BRIDGE}_INTERFACE_DIR}/array"      "${ARILES_BRIDGE_INCLUDE_DIR}/array")
add_dependencies("TGT_ariles_copy_headers_bridge_array_h" "TGT_ariles_copy_headers_bridge_array_dir")
add_dependencies("TGT_ariles_copy_headers_bridge_array_h" "TGT_ariles_copy_headers_ariles")


set (TGT_ARRAY            "${BRIDGE_TARGET_PREFIX}_${ARILES_BRIDGE}")
add_custom_target(${TGT_ARRAY})

include(ariles_install_component)

=== ariles/bridges/jsonnet/CMakeLists.txt ===
cmakeut_copy_file_if_exists( TGT_ariles_copy_headers                         "bridge_jsonnet_h"
                            "${${ARILES_BRIDGE}_INTERFACE_DIR}/jsonnet.h"   "${ARILES_BRIDGE_INCLUDE_DIR}/")
add_dependencies("TGT_ariles_copy_headers_bridge_jsonnet_h" "TGT_ariles_copy_headers_ariles")


set (TGT_JSONNET            "${BRIDGE_TARGET_PREFIX}_${ARILES_BRIDGE}")

set(JSONNET_SOURCE_DIR     "${CMAKE_CURRENT_LIST_DIR}/jsonnet")


if(NOT ARILES_DEB_TARGETS)
    if(${ARILES_BRIDGE_${ARILES_BRIDGE}} STREQUAL "BUILD")
        set (JSONNET_CXX_FLAGS      "${ARILES_CXX_FLAGS} -fPIC")

        set(JSONNET_ARGS
            ${BRIDGES_ARGS}
            -DBUILD_TESTS=OFF
            "-DCMAKE_CXX_FLAGS=${JSONNET_CXX_FLAGS}")

        if(ARILES_COPY_CXX_FLAGS_TO_C_FLAGS)
            set(JSONNET_ARGS
                ${JSONNET_ARGS}
                "-DCMAKE_C_FLAGS=${JSONNET_CXX_FLAGS}")
        endif(ARILES_COPY_CXX_FLAGS_TO_C_FLAGS)

        cmakeut_add_external_git_project(TARGET_NAME "${TGT_JSONNET}"
                                        PROJECT_DIR "${JSONNET_SOURCE_DIR}"
                                        CMAKE_ARGS   ${JSONNET_ARGS})

        set(ARILES_BRIDGE_${ARILES_BRIDGE}_INCLUDES "")
        set(ARILES_BRIDGE_${ARILES_BRIDGE}_LIBS
            "${ARILES_BRIDGES_LIBDIR}/${CMAKE_SHARED_LIBRARY_PREFIX}jsonnet${CMAKE_SHARED_LIBRARY_SUFFIX}")
        set(ARILES_BRIDGE_${ARILES_BRIDGE}_INCLUDE_HEADER "")
    else()
        add_custom_target(${TGT_JSONNET})

        find_library("ARILES_BRIDGE_${ARILES_BRIDGE}_LIBS" "jsonnet")
        if (NOT ARILES_BRIDGE_${ARILES_BRIDGE}_LIBS)
            message(FATAL_ERROR "Could not find jsonnet libraries. ${ARILES_BRIDGE_${ARILES_BRIDGE}_LIBS}")
        endif()

        find_path("ARILES_BRIDGE_${ARILES_BRIDGE}_INCLUDES" "libjsonnet.h")
        if (NOT ARILES_BRIDGE_${ARILES_BRIDGE}_INCLUDES)
            message(FATAL_ERROR "Could not find jsonnet headers. ${ARILES_BRIDGE_${ARILES_BRIDGE}_INCLUDES}")
        endif()

        set(ARILES_BRIDGE_${ARILES_BRIDGE}_INCLUDES "${ARILES_BRIDGE_${ARILES_BRIDGE}_INCLUDES}")
        set(ARILES_BRIDGE_${ARILES_BRIDGE}_LIBS "${ARILES_BRIDGE_${ARILES_BRIDGE}_LIBS}")
    endif()
endif()

include(ariles_install_component)

=== ariles/bridges/msgpack/CMakeLists.txt ===
cmakeut_copy_file_if_exists( TGT_ariles_copy_headers                         "bridge_msgpack_h"
                            "${${ARILES_BRIDGE}_INTERFACE_DIR}/msgpack.h"   "${ARILES_BRIDGE_INCLUDE_DIR}/")
cmakeut_copy_dir_if_exists(  TGT_ariles_copy_headers                         "bridge_msgpack_dir"
                            "${${ARILES_BRIDGE}_INTERFACE_DIR}/msgpack"     "${ARILES_BRIDGE_INCLUDE_DIR}/msgpack")
add_dependencies("TGT_ariles_copy_headers_bridge_msgpack_h" "TGT_ariles_copy_headers_bridge_msgpack_dir")
add_dependencies("TGT_ariles_copy_headers_bridge_msgpack_h" "TGT_ariles_copy_headers_ariles")

set(MESSAGEPACK_SOURCE_DIR   "${CMAKE_CURRENT_LIST_DIR}/msgpack-c")

set (TGT_MESSAGEPACK            "${BRIDGE_TARGET_PREFIX}_${ARILES_BRIDGE}")
if(NOT ARILES_DEB_TARGETS)
    if(${ARILES_BRIDGE_${ARILES_BRIDGE}} STREQUAL "BUILD")
        set (MESSAGEPACK_CXX_FLAGS      "${ARILES_CXX_FLAGS} -fPIC")


        set(MESSAGEPACK_ARGS
            ${BRIDGES_ARGS}
            -DMSGPACK_USE_X3_PARSE=OFF
            -DMSGPACK_CXX17=OFF
            -DMSGPACK_CXX11=OFF
            -DMSGPACK_32BIT=OFF
            -DMSGPACK_BOOST=OFF
            -DMSGPACK_BUILD_EXAMPLES=OFF
            -DMSGPACK_BUILD_TESTS=OFF
            -DMSGPACK_ENABLE_CXX=ON
            -DMSGPACK_ENABLE_SHARED=OFF
            "-DCMAKE_CXX_FLAGS=${MESSAGEPACK_CXX_FLAGS}")

        if(ARILES_COPY_CXX_FLAGS_TO_C_FLAGS)
            set(MESSAGEPACK_ARGS
                ${MESSAGEPACK_ARGS}
                "-DCMAKE_C_FLAGS=${MESSAGEPACK_CXX_FLAGS}")
        endif(ARILES_COPY_CXX_FLAGS_TO_C_FLAGS)

        cmakeut_add_external_git_project(TARGET_NAME "${TGT_MESSAGEPACK}"
                                        PROJECT_DIR "${MESSAGEPACK_SOURCE_DIR}"
                                        CMAKE_ARGS   ${MESSAGEPACK_ARGS})

        set(ARILES_BRIDGE_${ARILES_BRIDGE}_INCLUDES "")
        set(ARILES_BRIDGE_${ARILES_BRIDGE}_LIBS
            "${ARILES_BRIDGES_LIBDIR}/${CMAKE_STATIC_LIBRARY_PREFIX}msgpackc${CMAKE_STATIC_LIBRARY_SUFFIX}")
    else()
        pkg_search_module(${ARILES_BRIDGE} msgpack)

        if (${ARILES_BRIDGE}_FOUND)
            add_custom_target(${TGT_MESSAGEPACK})
            set(ARILES_BRIDGE_${ARILES_BRIDGE}_LIBRARY_DIRS "${${ARILES_BRIDGE}_LIBRARY_DIRS}")
            set(ARILES_BRIDGE_${ARILES_BRIDGE}_INCLUDES "${${ARILES_BRIDGE}_INCLUDE_DIRS}")
            set(ARILES_BRIDGE_${ARILES_BRIDGE}_LIBS "${${ARILES_BRIDGE}_LIBRARIES}")
        else()
            add_custom_target(${TGT_MESSAGEPACK})

            find_library("ARILES_BRIDGE_${ARILES_BRIDGE}_LIBS" NAMES ${ARILES_BRIDGE})
            if (${ARILES_BRIDGE_${ARILES_BRIDGE}_LIBS}-NOTFOUND)
                message(FATAL_ERROR "${ARILES_BRIDGE} is not found.")
            endif()

            find_path("ARILES_BRIDGE_${ARILES_BRIDGE}_INCLUDES" NAMES msgpack.hpp)
            if (${ARILES_BRIDGE_${ARILES_BRIDGE}_INCLUDES}-NOTFOUND)
                message(FATAL_ERROR "${ARILES_BRIDGE} is not found.")
            endif()
        endif()
    endif()
endif()

include(ariles_install_component)

=== ariles/bridges/octave/CMakeLists.txt ===
cmakeut_copy_file_if_exists( TGT_ariles_copy_headers                         "bridge_octave_h"
                            "${${ARILES_BRIDGE}_INTERFACE_DIR}/octave.h"    "${ARILES_BRIDGE_INCLUDE_DIR}/")
cmakeut_copy_dir_if_exists(  TGT_ariles_copy_headers                         "bridge_octave_dir"
                            "${${ARILES_BRIDGE}_INTERFACE_DIR}/octave"      "${ARILES_BRIDGE_INCLUDE_DIR}/octave")
add_dependencies("TGT_ariles_copy_headers_bridge_octave_h" "TGT_ariles_copy_headers_bridge_octave_dir")
add_dependencies("TGT_ariles_copy_headers_bridge_octave_h" "TGT_ariles_copy_headers_ariles")


set (TGT_OCTAVE            "${BRIDGE_TARGET_PREFIX}_${ARILES_BRIDGE}")
add_custom_target(${TGT_OCTAVE})

include(ariles_install_component)

=== ariles/bridges/pugixml/CMakeLists.txt ===
cmakeut_copy_file_if_exists( TGT_ariles_copy_headers                             "bridge_pugixml_h"
                            "${${ARILES_BRIDGE}_INTERFACE_DIR}/pugixml.h"       "${ARILES_BRIDGE_INCLUDE_DIR}/")
cmakeut_copy_dir_if_exists(  TGT_ariles_copy_headers                             "bridge_pugixml_dir"
                            "${${ARILES_BRIDGE}_INTERFACE_DIR}/pugixml"         "${ARILES_BRIDGE_INCLUDE_DIR}/pugixml")
add_dependencies("TGT_ariles_copy_headers_bridge_pugixml_h" "TGT_ariles_copy_headers_bridge_pugixml_dir")
add_dependencies("TGT_ariles_copy_headers_bridge_pugixml_h" "TGT_ariles_copy_headers_ariles")

set(PUGIXML_SOURCE_DIR     "${CMAKE_CURRENT_LIST_DIR}/pugixml")

set (TGT_PUGIXML            "${BRIDGE_TARGET_PREFIX}_${ARILES_BRIDGE}")
if(NOT ARILES_DEB_TARGETS)
    if(${ARILES_BRIDGE_${ARILES_BRIDGE}} STREQUAL "BUILD")
        set (PUGIXML_CXX_FLAGS      "${ARILES_CXX_FLAGS} -fPIC")


        set(PUGIXML_ARGS
            ${BRIDGES_ARGS}
            "-DCMAKE_CXX_FLAGS=${PUGIXML_CXX_FLAGS}")

        if(ARILES_COPY_CXX_FLAGS_TO_C_FLAGS)
            set(PUGIXML_ARGS
                ${PUGIXML_ARGS}
                "-DCMAKE_C_FLAGS=${PUGIXML_CXX_FLAGS}")
        endif(ARILES_COPY_CXX_FLAGS_TO_C_FLAGS)

        cmakeut_add_external_git_project(TARGET_NAME "${TGT_PUGIXML}"
                                        PROJECT_DIR "${PUGIXML_SOURCE_DIR}"
                                        CMAKE_ARGS   ${PUGIXML_ARGS})

        set(ARILES_BRIDGE_${ARILES_BRIDGE}_INCLUDES "")
        set(ARILES_BRIDGE_${ARILES_BRIDGE}_LIBS
            "${ARILES_BRIDGES_LIBDIR}/${CMAKE_STATIC_LIBRARY_PREFIX}pugixml${CMAKE_STATIC_LIBRARY_SUFFIX}")
    else()
        pkg_search_module(${ARILES_BRIDGE} pugixml)


        if (${ARILES_BRIDGE}_FOUND)
            add_custom_target(${TGT_PUGIXML})
            set(ARILES_BRIDGE_${ARILES_BRIDGE}_LIBRARY_DIRS "${${ARILES_BRIDGE}_LIBRARY_DIRS}")
            set(ARILES_BRIDGE_${ARILES_BRIDGE}_INCLUDES "${${ARILES_BRIDGE}_INCLUDE_DIRS}")
            set(ARILES_BRIDGE_${ARILES_BRIDGE}_LIBS "${${ARILES_BRIDGE}_LIBRARIES}")
        else()
            add_custom_target(${TGT_PUGIXML})

            set(ARILES_BRIDGE_${ARILES_BRIDGE}_LIBRARY_DIRS "")

            find_library("ARILES_BRIDGE_${ARILES_BRIDGE}_LIBS" NAMES ${ARILES_BRIDGE})
            if (${ARILES_BRIDGE_${ARILES_BRIDGE}_LIBS}-NOTFOUND)
                message(FATAL_ERROR "${ARILES_BRIDGE} is not found.")
            endif()

            find_path("ARILES_BRIDGE_${ARILES_BRIDGE}_INCLUDES" NAMES pugixml.hpp)
            if (${ARILES_BRIDGE_${ARILES_BRIDGE}_INCLUDES}-NOTFOUND)
                message(FATAL_ERROR "${ARILES_BRIDGE} is not found.")
            endif()
        endif()
    endif()
endif()

include(ariles_install_component)
set(DEB_${ARILES_COMPONENT}_DEPENDS "libpugixml-dev")

=== debian/changelog ===
ros-melodic-ariles-ros (1.3.2-1bionic) bionic; urgency=high

  * Sync to 1.3.2 (bugfixes).

 -- Alexander Sherikov <asherikov@yandex.com>  Sun, 15 Dec 2019 23:00:00 -0000

ros-melodic-ariles-ros (1.3.1-1bionic) bionic; urgency=high

  * Sync to 1.3.1
  * Fix bugs in cmake scripts.
  * Enable 'array' bridge.

 -- Alexander Sherikov <asherikov@yandex.com>  Tue, 22 Oct 2019 22:00:00 -0000

ros-melodic-ariles-ros (1.1.5-1bionic) bionic; urgency=high

  * Sync to 1.1.5.
  * Remove setup.sh and other helpers from the package.
  * More thorough testing.

 -- Alexander Sherikov <asherikov@yandex.com>  Mon, 03 Jun 2019 22:00:00 -0000

ros-melodic-ariles-ros (1.1.1-1bionic) bionic; urgency=high

  * Sync to 1.1.1, added README.md
  * Initial ROS release.

 -- Alexander Sherikov <asherikov@yandex.com>  Thu, 18 Apr 2019 22:00:00 -0000

=== debian/control ===
Source: ros-melodic-ariles-ros
Section: misc
Priority: optional
Maintainer: Alexander Sherikov <asherikov@yandex.com>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, libeigen3-dev, libyaml-cpp-dev, ros-melodic-catkin, ros-melodic-roscpp
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-ariles-ros
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libeigen3-dev, libyaml-cpp-dev, ros-melodic-roscpp
Description: Catkin package Ariles serialization/configuration library

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-ariles-ros//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install
